<?php
namespace Seria;

use Index\Environment;
use Index\Data\DbTools;

define('SERIA_STARTUP', microtime(true));
define('SERIA_ROOT', __DIR__);
define('SERIA_DEBUG', is_file(SERIA_ROOT . '/.debug'));
define('SERIA_DIR_SOURCE', SERIA_ROOT . '/src');
define('SERIA_DIR_MIGRATIONS', SERIA_ROOT . '/database');
define('SERIA_DIR_TEMPLATES', SERIA_ROOT . '/templates');

require_once SERIA_ROOT . '/vendor/autoload.php';

Environment::setDebug(SERIA_DEBUG);
mb_internal_encoding('utf-8');
date_default_timezone_set('utc');

require_once SERIA_ROOT . '/config.php';

$db = DbTools::create(SERIA_DSN);
$db->execute('SET SESSION time_zone = \'+00:00\', sql_mode = \'STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION\';');

$seria = new SeriaContext($db);
