<?php
namespace Seria\Auth;

use Index\Colour\Colour;
use Seria\Users\UserInfo;

class AuthInfo {
    private ?UserInfo $userInfo;

    public function __construct() {
        $this->setInfo();
    }

    public function setInfo(
        ?UserInfo $userInfo = null
    ): void {
        $this->userInfo = $userInfo;
    }

    public function removeInfo(): void {
        $this->setInfo();
    }

    public function isLoggedIn(): bool {
        return $this->userInfo !== null;
    }

    public function getUserId(): ?string {
        return $this->userInfo?->getId();
    }

    public function getUserName(): ?string {
        return $this->userInfo?->getName();
    }

    public function getUserColour(): ?Colour {
        return $this->userInfo?->getColour();
    }

    public function getUserInfo(): ?UserInfo {
        return $this->userInfo;
    }
}
